## picolibc 1.8.10

=== CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

cmake_minimum_required(VERSION 3.20.0)

project(Picolibc VERSION 1.8.10 LANGUAGES C ASM)

# Set a default build type if none was specified
set(default_build_type "MinSizeRel")

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES AND NOT DEFINED ZEPHYR_BASE)
  message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
      STRING "Choose the type of build." FORCE)
endif()

find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
  message(STATUS "Using ccache: ${CCACHE_PROGRAM}")
  set(CMAKE_C_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
endif()

if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "arm64")
  set(CMAKE_SYSTEM_PROCESSOR "aarch64")
endif()

set(CMAKE_SYSTEM_SUB_PROCESSOR ${CMAKE_SYSTEM_PROCESSOR})

if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "i686" OR
    ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64") 
  set(CMAKE_SYSTEM_PROCESSOR "x86")
endif()

if(ZEPHYR_BASE)
  if(NOT CONFIG_PICOLIBC_USE_MODULE)
    return()
  endif()
  include(zephyr/zephyr.cmake)
endif()

include(cmake/picolibc.cmake)

enable_testing()

set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)

# Set all configure values to defaults for now

# Use atomics for fgetc/ungetc for re-entrancy
set(__ATOMIC_UNGETC 1)

# Always optimize strcmp for performance
if(NOT DEFINED __FAST_STRCMP)
  option(__FAST_STRCMP "Always optimize strcmp for performance" ON)
endif()

# use global errno variable
if(NOT DEFINED __GLOBAL_ERRNO)
  option(__GLOBAL_ERRNO "use global errno variable" OFF)
endif()

# use thread local storage
if(NOT DEFINED __THREAD_LOCAL_STORAGE)
  option(__THREAD_LOCAL_STORAGE "use thread local storage for static data" ON)
endif()

# use thread local storage for stack protection canary
if(NOT DEFINED __THREAD_LOCAL_STORAGE_STACK_GUARD)
  option(__THREAD_LOCAL_STORAGE_STACK_GUARD "use thread local storage for stack protection canary" OFF)
endif()

option(POSIX_CONSOLE "Use POSIX I/O for stdin/stdout/stderr" OFF)

# Optimize for space over speed

if(NOT DEFINED __PREFER_SIZE_OVER_SPEED)
  if(CMAKE_BUILD_TYPE STREQUAL "MinSizeRel")
    set(default_prefer_size ON)
  else()
    set(default_prefer_size OFF)
  endif()
  option(__PREFER_SIZE_OVER_SPEED "Prefer smaller code size" ${default_prefer_size})
endif()

# Use tiny stdio from gcc avr
option(__TINY_STDIO "Use tiny stdio from avr libc" ON)

if(NOT TLS_MODEL)
  set(TLS_MODEL "local-exec")
endif()

set(_ATEXIT_DYNAMIC_ALLOC 0)

set(__FSEEK_OPTIMIZATION 0)

set(__FVWRITE_IN_STREAMIO 0)

# Use bitfields in packed structs
picolibc_flag(__HAVE_BITFIELDS_IN_PACKED_STRUCTS)

# Compiler has support for flag to prevent mis-optimizing memcpy/memset patterns
picolibc_flag(__HAVE_CC_INHIBIT_LOOP_TO_LIBCALL)

# Compiler supports _Complex
picolibc_flag(__HAVE_COMPLEX)

set(__HAVE_FCNTL 0)

# IEEE fp funcs available
set(__IEEEFP_FUNCS 0)

# compiler supports INIT_ARRAY sections
set(__INIT_FINI_ARRAY 1)

# Support _init() and _fini() functions
set(__INIT_FINI_FUNCS 1)

# Enable MMU in pico crt startup
set(__PICOCRT_ENABLE_MMU 1)

# _set_tls and _init_tls functions available
if(NOT DEFINED __THREAD_LOCAL_STORAGE_API OR NOT __THREAD_LOCAL_STORAGE)
  set(__THREAD_LOCAL_STORAGE_API 0)
endif()

set(__SEMIHOST 1)

# math library does not set errno (offering only ieee semantics)
set(__IEEE_LIBM 1)

if(NOT DEFINED __IO_FLOAT_EXACT)
  option(__IO_FLOAT_EXACT "Provide exact binary/decimal conversion for printf/scanf" ON)
endif()

set(__PICO_EXIT 1)

if(NOT DEFINED __ASSERT_VERBOSE)
  option(__ASSERT_VERBOSE "Assert provides verbose information" ON)
endif()

if(NOT DEFINED __MB_CAPABLE)
  option(__MB_CAPABLE "Enable multi-byte support" OFF)
endif()

if(NOT DEFINED __MB_EXTENDED_CHARSETS_ALL)
  option(__MB_EXTENDED_CHARSETS_ALL "Enable UCS, ISO, Windows and JIS multibyte encodings" OFF)
endif()

if(NOT DEFINED __MB_EXTENDED_CHARSETS_UCS)
  option(__MB_EXTENDED_CHARSETS_UCS "Enable UCS encodings" OFF)
endif()

if(NOT DEFINED __MB_EXTENDED_CHARSETS_ISO)
  option(__MB_EXTENDED_CHARSETS_ISO "Enable ISO encodings" OFF)
endif()

if(NOT DEFINED __MB_EXTENDED_CHARSETS_WINDOWS)
  option(__MB_EXTENDED_CHARSETS_WINDOWS "Enable Windows encodings" OFF)
endif()

if(NOT DEFINED __MB_EXTENDED_CHARSETS_JIS)
  option(__MB_EXTENDED_CHARSETS_JIS "Enable JIS multibyte encodings" OFF)
endif()

set(__NANO_FORMATTED_IO OFF)

option(__NANO_MALLOC "Use smaller malloc implementation" ON)

set(_GLOBAL_ATEXIT OFF)

set(__UNBUF_STREAM_OPT OFF)

if(NOT DEFINED __IO_C99_FORMATS)
  option(__IO_C99_FORMATS "Support C99 formats in printf/scanf" ON)
endif()

if(NOT DEFINED __IO_LONG_LONG)
  option(__IO_LONG_LONG "Support long long in integer printf/scanf" OFF)
endif()

if(NOT DEFINED __IO_LONG_DOUBLE)
  option(__IO_LONG_DOUBLE "Support long double in printf/scanf" OFF)
endif()

if(NOT DEFINED __IO_MINIMAL_LONG_LONG)
  option(__IO_MINIMAL_LONG_LONG "Support long long in minimal printf/scanf" OFF)
endif()

if(NOT DEFINED __IO_POS_ARGS)
  option(__IO_POS_ARGS "Support positional args in integer printf/scanf" OFF)
endif()

option(__IO_FLOAT "Support floating point in printf/scanf by default" ON)

if(NOT DEFINED __IO_SMALL_ULTOA)
  option(__IO_SMALL_ULTOA "Avoid soft divide in printf" ON)
endif()

if(NOT DEFINED __IO_PERCENT_N)
  option(__IO_PERCENT_N "Support %n formats in printf" OFF)
endif()

if(NOT DEFINED __IO_PERCENT_B)
  option(__IO_PERCENT_B "Support %b/%B formats in printf/scanf" OFF)
endif()

if(NOT DEFINED __IO_WCHAR)
  option(__IO_WCHAR "Support %ls/%lc formats in printf even without multi-byte" OFF)
endif()

if(NOT DEFINED __IO_DEFAULT)
  set(__IO_DEFAULT d)
endif()

# math library sets errno
set(__MATH_ERRNO OFF)

set(_WANT_REGISTER_FINI OFF)

set(__WIDE_ORIENT OFF)

if(NOT DEFINED __ELIX_LEVEL)
  set(__ELIX_LEVEL 4)
endif()

# Use old math code for double funcs (0 no, 1 yes)
set(__OBSOLETE_MATH_FLOAT ON)

# Use old math code for double funcs (0 no, 1 yes)
set(__OBSOLETE_MATH_DOUBLE ON)

# Compute static memory area sizes at runtime instead of link time
set(__PICOCRT_RUNTIME_SIZE OFF)

if(NOT DEFINED __SINGLE_THREAD)
  option(__SINGLE_THREAD "Disable multithreading support" OFF)
endif()

set(NEWLIB_VERSION 4.3.0)
set(NEWLIB_MAJOR 4)
set(NEWLIB_MINOR 3)
set(NEWLIB_PATCH 0)

set(PICOLIBC_INCLUDE ${PROJECT_BINARY_DIR}/picolibc/include)

set(PICOLIBC_SCRIPTS "${CMAKE_CURRENT_SOURCE_DIR}/scripts")

include(CheckIncludeFile)

CHECK_INCLUDE_FILE(xtensa/config/core-isa.h _XTENSA_HAVE_CONFIG_CORE_ISA_H)

configure_file(picolibc.h.in "${PICOLIBC_INCLUDE}/picolibc.h")

set(INCLUDEDIR include)
set(LIBDIR .)
if(__THREAD_LOCAL_STORAGE)
  set(TLSMODEL "-ftls-model=${TLS_MODEL}")
endif()
set(LINK_SPEC "")
set(CC1_SPEC "")
set(CC1PLUS_SPEC "")
set(ADDITIONAL_LIBS "")
set(SPECS_EXTRA "")
set(SPECS_ISYSTEM "-isystem ${PROJECT_BINARY_DIR}/${include}")
set(SPECS_LIBPATH "-L${PROJECT_BINARY_DIR}")
set(SPECS_STARTFILE "${PROJECT_BINARY_DIR}/crt0.o")
string(APPEND SPECS_PRINTF "%{DPICOLIBC_FLOAT_PRINTF_SCANF:--defsym=vfprintf=__f_vfprintf}"
  " %{DPICOLIBC_FLOAT_PRINTF_SCANF:--defsym=vfscanf=__f_vfscanf}"
  " %{DPICOLIBC_DOUBLE_PRINTF_SCANF:--defsym=vfprintf=__d_vfprintf}"
  " %{DPICOLIBC_DOUBLE_PRINTF_SCANF:--defsym=vfscanf=__d_vfscanf}"
  " %{DPICOLIBC_INTEGER_PRINTF_SCANF:--defsym=vfprintf=__i_vfprintf}"
  " %{DPICOLIBC_INTEGER_PRINTF_SCANF:--defsym=vfscanf=__i_vfscanff}"
  " %{DPICOLIBC_MINIMAL_PRINTF_SCANF:--defsym=vfprintf=__m_vfprintf}"
  " %{DPICOLIBC_MINIMAL_PRINTF_SCANF:--defsym=vfscanf=__i_vfscanff}"
  )
set(PREFIX "${PROJECT_BINARY_DIR}")

configure_file(picolibc.specs.in "${PROJECT_BINARY_DIR}/picolibc.specs" @ONLY)

set(PICOLIBC_COMPILE_OPTIONS
  "-nostdlib"
  "-D_LIBC"
  ${TLSMODEL}
  ${TARGET_COMPILE_OPTIONS}
  ${PICOLIBC_EXTRA_COMPILE_OPTIONS}
  ${PICOLIBC_MATH_FLAGS}
  )

# Strip out any generator expressions as those cannot be used with
# try_compile

foreach(c_option "${PICOLIBC_COMPILE_OPTIONS}")
  if(NOT "${c_option}" MATCHES "\\$")
    list(APPEND PICOLIBC_TEST_COMPILE_OPTIONS "${c_option}")
  endif()
endforeach()

picolibc_supported_compile_options(
  "-fno-common"
  "-fno-stack-protector"
  "-ffunction-sections"
  "-fdata-sections"
  "-Wall"
  "-Wextra"
  "-Werror=implicit-function-declaration"
  "-Werror=vla"
  "-Warray-bounds"
  "-Wold-style-definition"
  "-frounding-math"
  "-fsignaling-nans"
  )

add_library(c STATIC)

target_compile_options(c PRIVATE ${PICOLIBC_COMPILE_OPTIONS})

set(PICOLIBC_INCLUDE_DIRECTORIES
  "${PICOLIBC_INCLUDE}")

target_include_directories(c SYSTEM PUBLIC ${PICOLIBC_INCLUDE_DIRECTORIES})

define_property(GLOBAL PROPERTY PICOLIBC_HEADERS
  BRIEF_DOCS "Installed header files"
  FULL_DOCS "These are names of header files which are to be installed.")

add_subdirectory(newlib)

install(TARGETS c
  LIBRARY DESTINATION lib
  PUBLIC_HEADER DESTINATION include)

option(TESTS "Enable tests" OFF)
if(TESTS)

  # This could use some generalization, but it's good enough to do
  # semihosting-based tests

  add_subdirectory(semihost)
  add_subdirectory(picocrt)

  set(PICOCRT_OBJ $<TARGET_OBJECTS:picocrt>)
  set(PICOCRT_SEMIHOST_OBJ $<TARGET_OBJECTS:picocrt-semihost>)

  # semihost and libc have mutual-dependencies, so place them in a
  # linker group

  set(PICOLIBC_TEST_LINK_LIBRARIES
    ${PICOCRT_SEMIHOST_OBJ}
    -Wl,--start-group c semihost -Wl,--end-group
    ${PICOLIBC_LINK_FLAGS}
    )

  add_subdirectory(test)

endif()

install(FILES ${CMAKE_BINARY_DIR}/picolibc.specs DESTINATION lib)
install(FILES ${CMAKE_BINARY_DIR}/picolibc/include/picolibc.h DESTINATION include)

=== meson_options.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2019 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# General build options
#

option('multilib', type: 'boolean', value: true,
       description: 'Enable multilib compile')
option('multilib-list', type: 'array', value: [],
       description: 'List of multilib configurations to build for')
option('multilib-exclude', type: 'array', value: [],
       description: 'Multilib configurations containing any of these strings will not be built')
option('sanitize-bounds', type: 'boolean', value: false,
       description: 'Build the library with -fsanitize=bounds')
option('sanitize-undefined', type: 'boolean', value: false,
       description: 'Build the library with -fsanitize=undefined')
option('sanitize-trap-on-error', type: 'boolean', value: false,
       description: 'Build the library with -fsanitize-undefined-trap-on-error')
option('sanitize-allow-missing', type: 'boolean', value: false,
       description: 'Do not bail if sanitizer is requested but unavailable')
option('profile', type: 'boolean', value: false,
       description: 'Enable profiling by adding -pg -no-pie to compile flags')
option('analyzer', type: 'boolean', value: false,
       description: 'Enable the analyzer while compiling with -fanalyzer')
option('assert-verbose', type: 'boolean', value: true,
       description: 'Assert provides verbose information')
option('fast-strcmp', type: 'boolean', value: true,
       description: 'Always optimize strcmp for performance')

#
# Installation options
#

option('build-type-subdir', type: 'string',
       description: 'Build-type subdir. Also skips installing .specs file')
option('specsdir', type: 'string',
       description: 'Installation directory for .specs file')
option('sysroot-install', type: 'boolean', value: false,
       description: 'Install in gcc sysroot')
option('sysroot-install-skip-checks', type: 'boolean', value: false,
       description: 'Skip sysroot path checks during config')
option('system-libc', type: 'boolean', value: false,
       description: 'Install as system C library')

#
# Testing options
#

option('tests', type: 'boolean', value: false,
       description: 'Enable tests')
option('tests-cdefs', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'Enable test of sys/cdefs.h. If set to auto, enable when tests are enabled')
option('tests-enable-stack-protector', type: 'boolean', value: true,
       description: 'tests enable stack protector')
option('tests-enable-full-malloc-stress', type: 'boolean', value: false,
       description: 'tests enable stress test for full malloc')
option('tests-enable-posix-io', type: 'boolean', value: true,
       description: 'tests enable posix-io when available')
option('test-long-double', type: 'boolean', value: true,
       description: 'Enable long double tests on targets with long double type')
option('split-large-tests', type: 'boolean', value: false,
       description: 'Split large tests into pieces for smaller targets')
option('test-stdin', type: 'boolean', value: false,
       description: 'Enable tests that use stdin. This only works on a few targets')
option('fortify-source', type: 'combo', choices: ['none', '1', '2', '3'], value: '3',
       description: 'Set _FORTIFY_SOURCE=<value> when building tests')
option('test-machine', type: 'string', value: 'qemu',
       description: 'Machine-specific startup code to use when running tests')
option('freestanding', type: 'boolean', value: false,
       description: 'Build the library with -ffreestanding (useful for Zephyr testing)')
option('native-tests', type: 'boolean', value: false,
       description: 'Run some tests against native libc too')
option('native-math-tests', type: 'boolean', value: true,
       description: 'Run math tests against native libm when native-tests is enable')
option('use-stdlib', type: 'boolean', value: false,
       description: 'Do not bypass the standard system library with -nostdlib (useful for native testing)')
option('picolib', type: 'boolean', value: true,
       description: 'Include pico lib bits. Disable when doing native testing.')
option('semihost', type: 'boolean', value: true,
       description: 'Include semihost bits. Disable when doing native testing.')
option('fake-semihost', type: 'boolean', value: false,
       description: 'create fake semihost library to link tests')

#
# Stdio options
#

option('tinystdio', type: 'boolean', value: true,
       description: 'Use tiny stdio from avr libc')
option('io-c99-formats', type: 'boolean', value: true,
       description: 'enable C99 support in IO functions like printf/scanf')
option('io-long-long', type: 'boolean', value: false,
       description: 'enable long long type support in IO functions like printf/scanf')
option('io-pos-args', type: 'boolean', value: false,
       description: 'enable printf-family positional arg support (always enabled for tinystdio float)')
option('io-long-double', type: 'boolean', value: false,
       description: 'enable long double type support in IO functions printf/scanf')

#
# Tinystdio options
#

option('io-float-exact', type: 'boolean', value: true,
       description: 'use float/string code which supports round-tripping')
option('atomic-ungetc', type: 'boolean', value: true,
       description: 'use atomics in fgetc/ungetc to make them re-entrant')
option('posix-console', type: 'boolean', value: false,
       description: 'Use POSIX I/O for stdin/stdout/stderr')
option('format-default', type: 'combo', choices: ['double', 'float', 'long-long', 'integer', 'minimal', 'd', 'f', 'l', 'i', 'm'], value: 'd',
       description: 'which printf/scanf versions should be the default')
option('printf-aliases', type: 'boolean', value: true,
       description: 'Allow link-time printf aliases')
option('io-percent-b', type: 'boolean', value: false,
       description: 'enable proposed %b/%B format in printf and scanf in tinystdio (default: false)')
option('printf-small-ultoa', type: 'boolean', value: true,
       description: 'Avoid softare division in decimal conversions')
option('printf-percent-n', type: 'boolean', value: false,
       description: 'Support %n in printf format strings (default: false)')
option('minimal-io-long-long', type: 'boolean', value: false,
       description: 'enable long long type support in minimal printf/scanf')
option('fast-bufio', type: 'boolean', value: false,
       description: 'enable some faster buffered i/o operations')
option('io-wchar', type: 'boolean', value: false,
       description: 'enable wide character support in printf/scanf (requires multi-byte support)')
option('stdio-locking', type: 'boolean', value: false,
       description: 'perform POSIX-conforming file locking for all stdio operations')

#
# Legacy stdio options
#

option('newlib-elix-level', type: 'integer', value: 4,
       description: 'desired elix library level (0-4)')
option('newlib-fseek-optimization', type: 'boolean', value: false,
       description: 'enable fseek optimization')
option('newlib-fvwrite-in-streamio', type: 'boolean', value: false,
       description: 'disable iov in streamio')
option('newlib-io-float', type: 'boolean', value: false,
       description: 'enable printf/scanf family float support')
option('newlib-nano-formatted-io', type: 'boolean', value: false,
       description: 'Use nano version formatted IO')
option('newlib-stdio64', type: 'boolean', value: true,
       description: 'Include stdio64 with newlib stdio')
option('newlib-unbuf-stream-opt', type: 'boolean', value: false,
       description: 'enable unbuffered stream optimization in streamio')
option('newlib-wide-orient', type: 'boolean', value: false,
       description: 'Track wide orientation in streams.')
option('newlib-have-fcntl', type: 'boolean', value: false,
       description: 'System has fcntl function')

#
# Internationalization options
#

option('mb-capable', type: 'boolean', value: false,
       description: 'enable multibyte support for UTF-8 charset')
option('mb-extended-charsets', type: 'boolean', value: false,
       description: 'enable additional UCS, ISO-8859, JIS and Windows charsets')
option('mb-ucs-charsets', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'enable additional UCS encodings')
option('mb-iso-charsets', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'enable ISO-8859 encodings')
option('mb-jis-charsets', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'enable additional JIS multibyte encodings')
option('mb-windows-charsets', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'enable additional Windows encodings')

#
# Startup/shutdown options
#

option('picocrt', type: 'boolean', value: true,
       description: 'Include pico crt bits')
option('picocrt-enable-mmu', type: 'boolean', value: true,
       description: 'Enable memory management unit in picocrt startup')
option('picocrt-lib', type: 'boolean', value: true,
       description: 'Include pico crt bits in lib form')
option('picoexit', type: 'boolean', value: true,
       description: 'Smaller exit/atexit/onexit code')
option('initfini-array', type: 'boolean', value: true,
       description: 'compiler supports INIT_ARRAY section types')
option('initfini', type: 'boolean', value: false,
       description: 'Supports _init() and _fini()')
option('crt-runtime-size', type: 'boolean', value: false,
       description: 'compute crt memory space sizes at runtime')

#
# Legacy (non-picoexit) startup/shutdown options
#

option('newlib-atexit-dynamic-alloc', type: 'boolean', value: false,
       description: 'enable dynamic allocation of atexit entries')
option('newlib-global-atexit', type: 'boolean', value: false,
       description: 'make legacy atexit data structure global instead of thread-local')
option('newlib-register-fini', type: 'boolean', value: false,
       description: 'enable finalization function registration using atexit')

#
# Malloc options
#

option('newlib-nano-malloc', type: 'boolean', value: true,
       description: 'use small-footprint nano-malloc implementation')
option('nano-malloc-clear-freed', type: 'boolean', value: false,
       description: 'nano version erases memory on free/realloc')

#
# Locking options
#

option('single-thread', type: 'boolean', value: false,
       description: 'disable support for multiple threads')

#

=== hello-world/Makefile ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2019 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

CFLAGS=--oslib=semihost -Os

CFLAGS_RISCV=$(CFLAGS) -march=rv32imac -mabi=ilp32 -Triscv.ld
CC_RISCV=riscv64-unknown-elf-gcc -specs=picolibc.specs $(CFLAGS_RISCV)
CXXFLAGS_RISCV=$(CFLAGS) -march=rv32imac -mabi=ilp32 -Triscv-cpp.ld
CXX_RISCV=riscv64-unknown-elf-g++ -specs=picolibcpp.specs $(CXXFLAGS_RISCV)

CFLAGS_ARM=$(CFLAGS) -mcpu=cortex-m3 -Tarm.ld
CC_ARM=arm-none-eabi-gcc -specs=picolibc.specs $(CFLAGS_ARM)
CXXFLAGS_ARM=$(CFLAGS) -mcpu=cortex-m3 -Tarm-cpp.ld
CXX_ARM=arm-none-eabi-g++ -specs=picolibcpp.specs $(CXXFLAGS_ARM)

CFLAGS_AARCH64=$(CFLAGS) -Taarch64.ld
CC_AARCH64=aarch64-linux-gnu-gcc -specs=picolibc.specs $(CFLAGS_AARCH64)
CXXFLAGS_AARCH64=$(CFLAGS) -Taarch64-cpp.ld
CXX_AARCH64=aarch64-linux-gnu-g++ -specs=picolibcpp.specs $(CXXFLAGS_AARCH64)

all: \
	hello-world-arm.elf hello-world-aarch64.elf \
	hello-world-riscv.elf hello-world-native.elf \
	printf.elf printf-int.elf printf-float.elf

all-cpp: \
	hello-worldpp-arm.elf hello-worldpp-aarch64.elf \
	hello-worldpp-riscv.elf hello-worldpp-native.elf

hello-world-arm.elf: hello-world.c
	$(CC_ARM) -o $@ $^ -Wl,-Map=hello-world-arm.map

hello-world-aarch64.elf: hello-world.c
	$(CC_AARCH64) -o $@ $^ -Wl,-Map=hello-world-aarch64.map

hello-world-riscv.elf: hello-world.c
	$(CC_RISCV) -o $@ $^ -Wl,-Map=hello-world-riscv.map

hello-world-native.elf: hello-world.c
	cc -o $@ $^

printf.elf: printf.c
	$(CC_ARM) -o $@ $^ -Wl,-Map=printf.map

printf-int.elf: printf.c
	$(CC_ARM) --printf=i -o $@ $^ -Wl,-Map=printf-int.map

printf-float.elf: printf.c
	$(CC_ARM) --printf=f -o $@ $^ -Wl,-Map=printf-float.map

hello-worldpp-native.elf: hello-worldpp.cpp
	c++ -o $@ $^

hello-worldpp-arm.elf:  hello-worldpp.cpp
	$(CXX_ARM) -Wl,-Map=hello-worldpp-arm.map -o $@ $^

hello-worldpp-aarch64.elf:  hello-worldpp.cpp
	$(CXX_AARCH64) -Wl,-Map=hello-worldpp-aarch64.map -o $@ $^

hello-worldpp-riscv.elf:  hello-worldpp.cpp
	$(CXX_RISCV) -Wl,-Map=hello-worldpp-riscv.map -o $@ $^

clean:
	rm -f *.elf *.map

=== test/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

set(tests
  printf_scanf
  printf-tests
  rand
  regex
  ungetc
  fenv
  long_double
  math_errhandling
  malloc
  tls
  ffs
  setjmp
  atexit
  on_exit
  math-funcs
  timegm
  time-tests
  test-funopen
  test-strtod
  test-strchr
  test-memset
  test-put
  test-efcvt
  test-fma
  test-sprintf-percent-n
  malloc_stress
  test-memchr
  test-memcpy_s
  test-memset_s
  test-memmove_s
  test-strcat_s
  test-strcpy_s
  test-strerror_s
  test-strerrorlen_s
  test-strncat_s
  test-strncpy_s
  test-strnlen_s
  test-sprintf_s
  test-uchar
  test-vfprintf_s
  test-vsnprintf_s
  )

set(tests_fail
  test-except
  )
  
function(picolibc_test test)
  add_executable(${test} ${test}.c ${ARGN})

  target_link_libraries(${test} LINK_PUBLIC ${PICOLIBC_TEST_LINK_LIBRARIES})

  target_compile_options(${test} PRIVATE -fno-builtin ${PICOLIBC_COMPILE_OPTIONS} -D_TEST_LONG_DOUBLE)

  target_link_options(${test} PRIVATE ${TARGET_COMPILE_OPTIONS})

  add_test(
    NAME ${test}
    COMMAND "${PICOLIBC_SCRIPTS}/${TEST_RUNNER}" $<TARGET_FILE:${test}>
    )
  set_tests_properties(${test} PROPERTIES SKIP_RETURN_CODE 77)
endfunction()

foreach(test IN LISTS tests)
  picolibc_test(${test})
endforeach()

foreach(test IN LISTS tests_fail)
  picolibc_test(${test})
  set_tests_properties(${test} PROPERTIES WILL_FAIL ON)
endforeach()

picolibc_test(rounding-mode rounding-mode-sub.c)

=== .github/workflows/Makefile ===
LINUX_DEPS=\
	make-workflow \
	head \
	variants-cmake \
	variants \
	targets-cmake-linux \
	steps-head \
	steps-cmake \
	steps-minsize \
	steps-release

all: linux.yml zephyr.yml coreboot.yml

linux.yml: $(LINUX_DEPS)
	./make-workflow > $@

ZEPHYR_DEPS=\
	make-workflow-zephyr \
	head-zephyr \
	variants \
	targets-zephyr \
	steps-head \
	steps-minsize \
	steps-release

zephyr.yml: $(ZEPHYR_DEPS)
	./make-workflow-zephyr > $@

COREBOOT_DEPS=\
	make-workflow-coreboot \
	head-coreboot \
	variants \
	targets-coreboot \
	steps-head \
	steps-minsize \
	steps-release

coreboot.yml: $(COREBOOT_DEPS)
	./make-workflow-coreboot > $@

clean:
	rm -f linux.yml zephyr.yml coreboot.yml

=== doc/printf-sample/Makefile ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2023 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

CFLAGS=-Os \
    -march=armv7-m \
    --specs=picolibc.specs \
    --oslib=semihost \
    --crt0=hosted \
    -Wl,--defsym=__flash=0 \
    -Wl,--defsym=__flash_size=0x00200000 \
    -Wl,--defsym=__ram=0x20000000 \
    -Wl,--defsym=__ram_size=0x200000

QEMU=qemu-system-arm -chardev stdio,id=stdio0 -semihosting-config enable=on,chardev=stdio0 -monitor none -serial none -machine mps2-an385,accel=tcg -nographic -kernel

DCFLAGS=$(CFLAGS) -DPICOLIBC_DOUBLE_PRINTF_SCANF
FCFLAGS=$(CFLAGS) -DPICOLIBC_FLOAT_PRINTF_SCANF
LCFLAGS=$(CFLAGS) -DPICOLIBC_LONG_LONG_PRINTF_SCANF
ICFLAGS=$(CFLAGS) -DPICOLIBC_INTEGER_PRINTF_SCANF
MCFLAGS=$(CFLAGS) -DPICOLIBC_MINIMAL_PRINTF_SCANF

CC=arm-none-eabi-gcc

LOG=printf.log printf-float.log printf-long-long.log printf-integer.log printf-minimal.log

ALL=printf.elf printf-float.elf printf-long-long.elf printf-integer.elf printf-minimal.elf

all: $(LOG)

printf.log: printf.elf
	(arm-none-eabi-size $^; $(QEMU) $^) > $@

printf.elf: printf.c
	$(CC) $(DCFLAGS) -o $@ $^

printf-float.log: printf-float.elf
	(arm-none-eabi-size $^; $(QEMU) $^) > $@

printf-float.elf: printf.c
	$(CC) $(FCFLAGS) -o $@ $^

printf-long-long.log: printf-long-long.elf
	(arm-none-eabi-size $^; $(QEMU) $^) > $@

printf-long-long.elf: printf.c
	$(CC) $(LCFLAGS) -o $@ $^

printf-integer.log: printf-integer.elf
	(arm-none-eabi-size $^; $(QEMU) $^) > $@

printf-integer.elf: printf.c
	$(CC) $(ICFLAGS) -o $@ $^

printf-minimal.log: printf-minimal.elf
	(arm-none-eabi-size $^; $(QEMU) $^) > $@

printf-minimal.elf: printf.c
	$(CC) $(MCFLAGS) -o $@ $^

clean:
	rm -f $(ALL) $(LOG)

=== newlib/libc/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

add_subdirectory(machine)

add_subdirectory(include)

add_subdirectory(argz)
add_subdirectory(ctype)
add_subdirectory(errno)
add_subdirectory(iconv)
add_subdirectory(misc)
add_subdirectory(picolib)
add_subdirectory(posix)
add_subdirectory(search)
add_subdirectory(signal)
add_subdirectory(ssp)
add_subdirectory(stdlib)
add_subdirectory(string)
add_subdirectory(time)
add_subdirectory(tinystdio)
add_subdirectory(uchar)
add_subdirectory(xdr)
add_subdirectory(locale)
add_subdirectory(ubsan)

=== newlib/libm/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

add_subdirectory(machine)
add_subdirectory(common)
add_subdirectory(math)
add_subdirectory(ld)
add_subdirectory(fenv)
if(${__HAVE_COMPLEX})
  add_subdirectory(complex)
endif()

=== newlib/libc/errno/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
picolibc_sources(
  errno.c
  )

=== newlib/libc/include/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
add_subdirectory(sys)
add_subdirectory(machine)
add_subdirectory(ssp)
add_subdirectory(rpc)
add_subdirectory(arpa)

picolibc_headers(""
  alloca.h
  argz.h
  ar.h
  assert.h
  byteswap.h
  cpio.h
  ctype.h
  devctl.h
  dirent.h
  endian.h
  envlock.h
  envz.h
  errno.h
  fastmath.h
  fcntl.h
  fenv.h
  fnmatch.h
  getopt.h
  glob.h
  grp.h
  iconv.h
  ieeefp.h
  inttypes.h
  langinfo.h
  libgen.h
  limits.h
  locale.h
  malloc.h
  math.h
  memory.h
  ndbm.h
  newlib.h
  paths.h
  picotls.h
  pwd.h
  regdef.h
  regex.h
  sched.h
  search.h
  setjmp.h
  signal.h
  spawn.h
  stdint.h
  stdnoreturn.h
  stdlib.h
  string.h
  strings.h
  _syslist.h
  tar.h
  termios.h
  time.h
  uchar.h
  unctrl.h
  unistd.h
  utime.h
  utmp.h
  wchar.h
  wctype.h
  wordexp.h
  )

if(${__HAVE_COMPLEX})
  picolibc_headers(""
    complex.h
    )
endif()

=== newlib/libc/locale/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2025 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
picolibc_sources(
  duplocale.c
  freelocale.c
  getlocalename_l.c
  localeconv.c
  localedata.c
  locale_ctype_ptr.c
  locale_ctype_ptr_l.c
  localedata.c
  locale_mb_cur_max.c
  locale_names.c
  newlocale.c
  nl_langinfo.c
  setlocale.c
  timedata.c
  uselocale.c
  )

target_include_directories(c PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}")

=== newlib/libc/machine/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${CMAKE_SYSTEM_PROCESSOR}/CMakeLists.txt)
  add_subdirectory(${CMAKE_SYSTEM_PROCESSOR})
endif()

if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64" OR
    ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "i686")
  add_subdirectory(shared_x86)
endif()

=== debian/changelog ===
picolibc (1.8.10-3) unstable; urgency=medium

  * Support cross builds.

 -- Keith Packard <keithp@keithp.com>  Mon, 01 Sep 2025 20:10:53 -0500

picolibc (1.8.10-2) unstable; urgency=medium

  * Add qemu version 10 patch for riscv. Closes: #1104372.

 -- Keith Packard <keithp@keithp.com>  Tue, 29 Apr 2025 21:40:39 -0700

picolibc (1.8.10-1) unstable; urgency=medium

  * New upstream

  * Skip aarch64 and riscv64 tests on hosts without relevant qemu.
    Closes: #1103122.

 -- Keith Packard <keithp@keithp.com>  Mon, 14 Apr 2025 09:51:41 -0700

=== debian/control ===
Source: picolibc
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Build-Depends: debhelper-compat (= 13), gcc-arm-none-eabi, gcc-riscv64-unknown-elf, gcc-xtensa-lx106,
 gcc-aarch64-linux-gnu, meson, ninja-build, qemu-system-arm, qemu-system-misc
Standards-Version: 4.7.0
Rules-Requires-Root: no
Section: devel
Homepage: https://keithp.com/picolibc
Vcs-Git: git://keithp.com/git/picolibc.git -b debian
Vcs-Browser: https://keithp.com/cgit/picolibc.git/

Package: picolibc-riscv64-unknown-elf
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, gcc-riscv64-unknown-elf
Description: Smaller embedded C library for RISC-V development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 RISC-V processors.

Package: picolibc-arm-none-eabi
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, gcc-arm-none-eabi
Description: Smaller embedded C library for ARM development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 ARM processors. This library is intended to replace libnewlib-nano

Package: picolibc-xtensa-lx106-elf
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, gcc-xtensa-lx106
Description: Smaller embedded C library for ESP8266 development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 ESP8266 processors.

Package: picolibc-aarch64-linux-gnu
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, gcc-aarch64-linux-gnu
Description: Smaller embedded C library for 64-bit ARM development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 ARM 64-bit processors.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# Don't let dpkg-buildflags mess with the compiler settings
export DEB_CPPFLAGS_MAINT_SET =
export DEB_CXXFLAGS_MAINT_SET =
export DEB_CFLAGS_MAINT_SET =
export DEB_LDFLAGS_MAINT_SET =

BUILDDIR=build

DEBPATH=$(shell pwd)/debian
BUILDPATH=$(DEBPATH)/$(BUILDDIR)

%:
	dh $@ -B$(BUILDDIR)

RISCV_ARCH=riscv64-unknown-elf
ARM_ARCH=arm-none-eabi
LX106_ARCH=xtensa-lx106-elf
AARCH64_ARCH=aarch64-linux-gnu

MESON_SHARED_C_ARGS = -Wdate-time -ffile-prefix-map=$(BUILDPATH)=. -fdebug-prefix-map=$(BUILDPATH)=.

MESON_SHARED_FLAGS = \
	--prefix=/usr

MESON_RELEASE_FLAGS=-Dbuild-type-subdir=release --buildtype=release

MESON_RISCV_MINSIZE_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	-Dtests=true \
	-Dc_args='$(MESON_SHARED_C_ARGS) -msave-restore' \
	--cross-file scripts/cross-$(RISCV_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(RISCV_ARCH) \
	-Dincludedir=lib/picolibc/$(RISCV_ARCH)/include \
	-Dlibdir=lib/picolibc/$(RISCV_ARCH)/lib

MESON_RISCV_RELEASE_FLAGS = \
	$(MESON_RELEASE_FLAGS) \
	$(MESON_SHARED_FLAGS) \
	-Dtests=true \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	--cross-file scripts/cross-$(RISCV_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(RISCV_ARCH) \
	-Dincludedir=lib/picolibc/$(RISCV_ARCH)/include \
	-Dlibdir=lib/picolibc/$(RISCV_ARCH)/lib

MESON_ARM_MINSIZE_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	-Dtests=true \
	--cross-file scripts/cross-$(ARM_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(ARM_ARCH) \
	-Dincludedir=lib/picolibc/$(ARM_ARCH)/include \
	-Dlibdir=lib/picolibc/$(ARM_ARCH)/lib

MESON_ARM_RELEASE_FLAGS = \
	$(MESON_RELEASE_FLAGS) \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	-Dtests=true \
	--cross-file scripts/cross-$(ARM_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(ARM_ARCH) \
	-Dincludedir=lib/picolibc/$(ARM_ARCH)/include \
	-Dlibdir=lib/picolibc/$(ARM_ARCH)/lib

MESON_LX106_MINSIZE_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	--cross-file scripts/cross-$(LX106_ARCH).txt \
	-Dspecsdir=/usr/lib/$(LX106_ARCH) \
	-Dincludedir=lib/$(LX106_ARCH)/include \
	-Dlibdir=lib/$(LX106_ARCH)/lib

MESON_LX106_RELEASE_FLAGS = \
	$(MESON_RELEASE_FLAGS) \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	--cross-file scripts/cross-$(LX106_ARCH).txt \
	-Dspecsdir=/usr/lib/$(LX106_ARCH) \
	-Dincludedir=lib/$(LX106_ARCH)/include \
	-Dlibdir=lib/$(LX106_ARCH)/lib

MESON_AARCH64_MINSIZE_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	-Dtests=true \
	--cross-file scripts/cross-$(AARCH64_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(AARCH64_ARCH) \
	-Dincludedir=lib/picolibc/$(AARCH64_ARCH)/include \
	-Dlibdir=lib/picolibc/$(AARCH64_ARCH)/lib

MESON_AARCH64_RELEASE_FLAGS = \
	$(MESON_RELEASE_FLAGS) \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	-Dtests=true \
	--cross-file scripts/cross-$(AARCH64_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(AARCH64_ARCH) \
	-Dincludedir=lib/picolibc/$(AARCH64_ARCH)/include \
	-Dlibdir=lib/picolibc/$(AARCH64_ARCH)/lib

override_dh_autoreconf:
	echo 'no reconf needed'

override_dh_auto_clean:
	rm -fr debian/$(BUILDDIR)

override_dh_auto_configure:
	meson . debian/$(BUILDDIR)/$(RISCV_ARCH) $(MESON_RISCV_MINSIZE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(ARM_ARCH) $(MESON_ARM_MINSIZE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(LX106_ARCH) $(MESON_LX106_MINSIZE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(AARCH64_ARCH) $(MESON_AARCH64_MINSIZE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(RISCV_ARCH)-release $(MESON_RISCV_RELEASE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(ARM_ARCH)-release $(MESON_ARM_RELEASE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(LX106_ARCH)-release $(MESON_LX106_RELEASE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(AARCH64_ARCH)-release $(MESON_AARCH64_RELEASE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'

override_dh_auto_build:
	cd debian/$(BUILDDIR)/$(RISCV_ARCH) && ninja -v
	cd debian/$(BUILDDIR)/$(ARM_ARCH) && ninja -v
	cd debian/$(BUILDDIR)/$(LX106_ARCH) && ninja -v
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH) && ninja -v
	cd debian/$(BUILDDIR)/$(RISCV_ARCH)-release && ninja -v
	cd debian/$(BUILDDIR)/$(ARM_ARCH)-release && ninja -v
	cd debian/$(BUILDDIR)/$(LX106_ARCH)-release && ninja -v
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH)-release && ninja -v

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd debian/$(BUILDDIR)/$(ARM_ARCH) && meson test --timeout-multiplier=10
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH) && (test ! -x /usr/bin/qemu-system-aarch64 || meson test --timeout-multiplier=10 --wrapper=$(DEBPATH)/debian-run-aarch64)
	cd debian/$(BUILDDIR)/$(RISCV_ARCH) && (test ! -x /usr/bin/qemu-system-riscv64 || meson test --timeout-multiplier=10)
	cd debian/$(BUILDDIR)/$(ARM_ARCH)-release && meson test --timeout-multiplier=10
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH)-release && (test ! -x /usr/bin/qemu-system-aarch64 || meson test --timeout-multiplier=10 --wrapper=$(DEBPATH)/debian-run-aarch64)
	cd debian/$(BUILDDIR)/$(RISCV_ARCH)-release && (test ! -x /usr/bin/qemu-system-riscv64 || meson test --timeout-multiplier=10)
endif

override_dh_auto_install:
	cd debian/$(BUILDDIR)/$(RISCV_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(ARM_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(LX106_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(RISCV_ARCH)-release && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(ARM_ARCH)-release && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(LX106_ARCH)-release && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH)-release && DESTDIR=${CURDIR}/debian/tmp ninja install

=== debian/tests/control ===
Test-Command: riscv64-unknown-elf-gcc -mcmodel=medany -fno-stack-protector --specs=picolibc.specs --crt0=semihost --oslib=semihost -o /tmp/touch-risc-v debian/tests/touch.c
Depends: @, gcc-riscv64-unknown-elf
Architecture: amd64, i386, ppc64el, arm64, s390x

Test-Command: arm-none-eabi-gcc -fno-stack-protector --specs=picolibc.specs --crt0=semihost --oslib=semihost -o /tmp/touch-arm debian/tests/touch.c
Depends: @, gcc-arm-none-eabi
Architecture: amd64, i386, ppc64el, arm64, s390x

Test-Command: aarch64-linux-gnu-gcc -fno-stack-protector --specs=picolibc.specs --crt0=semihost --oslib=semihost -o /tmp/touch-aarch64 debian/tests/touch.c -Wl,--no-warn-rwx-segments
Depends: @, gcc-arm-none-eabi
Architecture: amd64, i386, ppc64el, arm64, s390x

=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=none" \
git://keithp.com/git/picolibc \
refs/tags/([12]\.[\d\.]+) debian uupdate
